part of cresce_ui;

class CButton extends StatefulWidget {
  final String label;
  final VoidCallback? onTap;
  final CButtonStyle style;
  final double? width;
  final IconData? icon;

  const CButton({
    Key? key,
    this.onTap,
    required this.label,
    this.style = const CPrimaryStyle(),
    this.width,
    this.icon,
  }) : super(key: key);

  @override
  State<CButton> createState() => _CButtonState();
}

class _CButtonState extends State<CButton> {
  late ButtonState _state;

  @override
  void initState() {
    super.initState();
    _state = widget.style.getDefaultState();
  }

  @override
  Widget build(BuildContext context) {
    return GestureDetector(
      onTapDown: (_) {
        setState(() => _state = widget.style.getTappedState());
      },
      onTapUp: (_) {
        setState(() => _state = widget.style.getDefaultState());
        widget.onTap?.call();
      },
      child: Stack(
        children: [
          Container(
            width: widget.width,
            height: 40.0,
            decoration: BoxDecoration(
              borderRadius: BorderRadius.circular(25.0),
              color: _state.backgroundColor,
              border: Border.all(width: 1.0, color: _state.borderColor),
            ),
            child: Center(
              child: CText(label: widget.label, style: _state.labelStyle),
            ),
          ),
          Positioned(
            height: 40,
            left: 22,
            child: Icon(
              widget.icon,
              size: 18.0,
              color: _state.labelStyle.color,
            ),
          ),
        ],
      ),
    );
  }
}
