part of cresce_ui;

class CMenuItem extends StatelessWidget {
  final String label;
  final IconData iconData;
  final VoidCallback? onTap;
  const CMenuItem({
    Key? key,
    required this.label,
    required this.iconData,
    this.onTap,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return GestureDetector(
      onTapUp: (_) => onTap?.call(),
      child: CSmallModal(
        size: const Size(250, 44),
        child: Padding(
          padding: const EdgeInsets.only(left: 20.0),
          child: Row(
            children: [
              Icon(iconData, size: 20.0, color: const Color(0xFF4CBAAC)),
              const SizedBox(width: 6.0),
              CText(label: label, style: CTextStyles.labelPrimary),
            ],
          ),
        ),
      ),
    );
  }
}
